



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>浅析 JavaScript 的函数节流和去抖</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">浅析 JavaScript 的函数节流和去抖</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 06:50:40 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>现代网页的实现上，会有很多交互上的优化，比如常见的&nbsp;<code>滚动加载</code>&nbsp;，<code>输入联想</code>&nbsp;等等。他们的实现思路很简单，以<code>滚动加载</code>而言，无非就是去是增加一个滚动的事件监听，每次滚动判断当前的元素是否已经滚动到了用户的可视区，然后根据判断结果来决定是否来加载相关数据。&nbsp;<code>输入联想</code>也类似，无非就是修改一下监听的事件类型，和判断的相关逻辑。</p>
<p>前端交互的优化上，我们总是需要需要事件监听来知道用户进行了什么操作，从而设定页面给出怎样的反应。但本文主要的内容不是讲如何具体的实现某个交互，而是对交互实现的依赖的事件监听那部分的优化。</p>
<h2>滚动加载图片的例子</h2>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />2<br />3<br />4<br />5<br />6<br />7<br />8</pre>
</td>
<td>
<pre class="prettyprint linenums">var onScroll = function() {<br />  // 这里判断当前的 img 元素是否已经滚动到了用户的可视区<br />  // 根据判断结果来决定是否来加载相关数据 <br />  // 注：img 元素当设置 src 属性值后会产生一个 http 的请求，加载图片<br />};

window.addEventListener('scroll',onScroll ,false);</pre>
</td>
</tr>
</tbody>
</table>
<p>这样理论上就实现了图片的滚动加载或者说是按需加载，懒加载等等。</p>
<p>这样的实现乍看没有任何问题，但在实际的场景中，问题还是很严重的。</p>
<p>如下：</p>
<div></div>
<p>很明显，当你在 codepen 中滚动鼠标的时候，显示的数字蹭蹭蹭的加大， 这个数字就是过程中，浏览器触发 scroll 事件的数字， 可以看出，浏览器触发 scroll 事件是很频繁的。</p>
<p>所以，回到上面提出的问题中，因为浏览器触发 scroll 会很平凡， 也就意味着事件的监听回调函数 onScroll 会被很频繁的执行。这就是问题之所在，且不说我们的 onScroll 里面的逻辑可能会是大量的计算。如此频繁的计算就算可以很轻松的被完成，结果也是没有意义的。所以我们要在这里来优化代码，倒不是优化 onScroll 本省，而是想办法让 onScroll 执行的次数可以减少。</p>
<h2>函数节流</h2>
<p>在原本的逻辑中，假设在滚动条连续的滚动中，浏览器每 10ms 触发一次scroll 事件，就意味着浏览器每 10ms 就要去执行一次 onScroll，如果想让 onScroll 不那么频繁的被执行，怎么办？</p>
<p>很明显，想去改动 scroll 触发的频率在前端这一层面上肯定是不行，因为他们浏览器自身的设定。那么是否可以在触发 scroll 事件之后，不直接调用 onScroll 函数从而进行优化呢？比如，假设scroll 事件持续触发，我们让 onScroll 函数每 250ms 触发。</p>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />2<br />3<br />4<br />5<br />6<br />7<br />8<br />9<br />10<br />11<br />12<br />13<br />14<br />15<br />16<br />17<br />18<br />19<br />20<br />21<br />22<br />23<br />24</pre>
</td>
<td>
<pre class="prettyprint linenums">var throttle = function() {<br />  var previous = 0;  // 初始设置上一次调用 onScroll 函数时间点为 0。<br />  var timeout; <br />  var wait = 250; // 该变量表示执行 onScroll 函数的间隔时间。<br />  // 返回一个函数 ，该函数在每次触发 scroll 事件时，真正调用的函数。<br />  return function() {<br />    var now = Date.now(); // 记录下当前触发 scroll 的时间<br />    var remaining = wait - (now - previous); // 持续的滚动过程中，计算得到调用 onScroll 的甚于时间<br />    if (remaining &lt;= 0) {<br />      if (timeout) {<br />        clearTimeout(timeout)<br />      }<br />      previous = now;<br />      timeout = null;<br />      onScroll();<br />    } else if(!timeout) { // 初始或者非持续滚动(滚动动作的时间小于 250ms )，设定一个定时器。<br />      timeout = setTimeout(onScroll, wait);<br />    }<br />  }<br />};

// 注意这里的调用方式<br />window.addEventListener('scroll',throttle() ,false);</pre>
</td>
</tr>
</tbody>
</table>
<p>这样调用是不会有结果的</p>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1</pre>
</td>
<td>
<pre class="prettyprint linenums">window.addEventListener('scroll',throttle ,false);</pre>
</td>
</tr>
</tbody>
</table>
<p>上述的代码旨在说明实现函数节流的思路，著名的&nbsp;<code>underscore.js</code>&nbsp;和&nbsp;<code>lodash</code>&nbsp;都有节流方法的实现。</p>
<h2>输入联想的例子</h2>
<p>当你在使用 google 搜索内容的时候，有些关键词输入到一般，谷歌会展示一个可选列表，是根据你当前输入的内容作出的一个猜测联想，如果有中目标的联想，你就可以不需要输入接下来的内容，直接选择自动补全就好。</p>
<p>这种场景下，我们一般是去监听用户的&nbsp;<code>onKeyRress</code>&nbsp;或者&nbsp;<code>onKeyUp</code>&nbsp;等等键盘事件。在当用户输入一些文字的时候，我们一监听到键盘事件就将用户当前输入的内容去发送一个 ajax 查询请求显然是不行的。那么在节流函数内部去调用 ajax 请求呢？</p>
<p>在这种场景下，其实函数节流也是不合适，因为，函数节流只是减小了函数执行的在事件触发过程中频率，将原来可能调用1000次减少到调用100次。然而对输入联想的场景来说，只要用户还在触发键盘事件，那么发送请求就是没有意义的。</p>
<p>所以，我们现在需要的一种实现是应该是在用户停止键盘事件一段时间后，去发送一个请求。</p>
<p>比如应该这么设计这个过程，用户在输入，用户输入有所停顿（也就是不再触发键盘事件），当这个事件大于 250ms 之后，去触发一个查询请求。 如果用户输入停顿的时间小于 250ms，不去发送查询请求。</p>
<h2>电梯模型</h2>
<p>输入联想的执行过程，应该和生活中的电梯执行过程是一样的。<br />比如，当你正在座电梯，当电梯门正要关闭的时候，这是有一个同学又冲过来，按了一下电梯的按钮，这个电梯门会打开然后等待一定的时间，如果在等待的过程中，又有另外一位同学过来按了按钮，之前等待的时间清零，继续等待一定的时间，直到在等待的时间中，不在有别的人去按按钮。门才会关闭，然后上下运行。</p>
<h2>函数去抖</h2>
<p>了解这个过程之后，来简单的实现下这个过程。</p>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />2</pre>
</td>
<td>
<pre class="prettyprint linenums">// 如下搜索控件<br />&lt;input type="search" name="search" /&gt;</pre>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />2<br />3<br />4<br />5<br />6<br />7<br />8<br />9<br />10<br />11<br />12<br />13<br />14</pre>
</td>
<td>
<pre class="prettyprint linenums">var sendAjax = function(obj) {<br />  // 发送请求<br />};<br />var debounce = function() {<br />  var wait = 2500;<br />  var timeout;<br />  return function () {<br />    if (timeout) clearTimeout(timeout);<br />    timeout = setTimeout(sendAjax, wait);<br />  }<br />};<br />var input = document.querySelector('input[name=search]');

input.addEventLister('keyup', debounce(), false);</pre>
</td>
</tr>
</tbody>
</table>
<h2>总结</h2>
<p>函数节流和函数去抖的使用场景略有不同。</p>
<p>函数节流：在事件触发过程中，减小相关回调函数的执行频率。<br />函数去抖：在事件触发结束后一定时间后去执行事件回调函数，如果在这一定时间内又触发了相关事件，则不去触发事件回调函数，下一次执行事件回调函数时间仍是确定的一定时间。</p>
<h3>相关文章和代码</h3>
<ul><ul><li><a href="https://css-tricks.com/debouncing-throttling-explained-examples/" rel="external nofollow noreferrer">Debouncing and Throttling Explained Through Examples</a></li>
<li><a href="https://github.com/jashkenas/underscore/blob/master/underscore.js#L806-L850" rel="external nofollow noreferrer">underscore.throttle</a></li>
<li><a href="https://github.com/jashkenas/underscore/blob/master/underscore.js#L852-L883" rel="external nofollow noreferrer">underscore.debounce</a></li>
<li><a href="https://github.com/lodash/lodash/blob/ee6ec2f6728eebf9f5beb2ecbca905fade1a32c1/debounce.js" rel="external nofollow noreferrer">lodash.debounce</a></li></ul></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv35o8x.html">2000条你应知的WPF小姿势 基础篇&amp;lt&semi;69-73 WPF Freeze机制和Template&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k47vj9.html">爬虫5  html下载器 html&lowbar;downloader&period;py</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p5y678.html">Mysql----------的一些常用命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m0g0p9.html">&lbrack;IR&rsqb; Probabilistic Model</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv0kyoq.html">Picker组件封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmvddk9.html">VC中监测函数运行时间（一）&mdash;分钟，秒，毫秒</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1lgxv9.html">Python 调用C&plus;&plus;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vzyvo8.html">Quartz&period;NET作业调度框架详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m7lgn8.html">浙江工商大学15年校赛C题 我删我删&comma;删删删 【简单模拟】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj1mme9.html">虚拟键盘冲击移动端fixed布局的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgnoye8.html">Lua入门基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj2rjz8.html">JProfiler的详细使用介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/9505lxe8.html">Percona-Toolkit 之 pt-online-schema-change 总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwnrgd8.html">活代码LINQ&mdash;&mdash;03</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyroxgq.html">ajax--参数默认值问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jkg65q.html">POJ 1988 Cube Stacking 【带权并查集】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ovwdj8.html">MDX Cookbook 07 - 在不同层次结构的成员中实现 逻辑 OR 的效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/96022kj9.html">JVM的7种垃圾收集器：主要特点 应用场景 设置参数 基本运行原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gl4zvq.html">施工测量中Cad一些非常有用的插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw6nnx9.html">sqlserver sql优化案例及思路</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1z05ez9.html">linq分组查询</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1n57x9.html">使用Calendar增加日期</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1nonz9.html">Linux的环境变量配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd1r4k8.html">常用财务软件：用友，金蝶，新中大，速达，管家婆，金算盘，远方，远光，金钥匙，润衡，浪潮，上海博科，易商，任我行，千方百剂，智管，小蜜蜂，SAP，ORACLE，SSA，QAD，MAPICS，JDE。</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0wljeq.html">Linux下（主要针对Ubuntu）下桌面分辨率的添加</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1de1n9.html">poj 3678 Katu Puzzle&lpar;2-sat&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmgp509.html">magento后台登陆后，没任何提示，又跳转到登陆页面</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1yrx59.html">安装jansson库【JSON库C语言版】</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj0v779.html">ORM框架Hibernate &lpar;一&rpar; 对DAO封装和抽象</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x4nvz8.html">RehHat enterprise 5&period;4 安装git</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
